<script setup>
import { onBeforeUnmount, toRef, watch } from 'vue';
import { useField } from 'vee-validate';
import { BFormInput } from 'bootstrap-vue';
const props = defineProps({
  type: {
    type: String,
    default: 'text',
  },
  value: {
    type: String,
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: null,
  },
  readonly: {
    type: Boolean,
    default: null,
  },
  
  autofocus: {
    type: Boolean,
    default: false,
  },
  name: {
    type: String,
    required: true,
  },
  maxlength: {
    type: Number,
    default: 1000000,
  },
  label: {
    type: String,
    required: true,
  },
  successMessage: {
    type: String,
    default: '',
  },
  placeholder: {
    type: String,
    default: '',
  },
});

// use `toRef` to create reactive references to `name` prop which is passed to `useField`
// this is important because vee-validte needs to know if the field name changes
// https://vee-validate.logaretm.com/v4/guide/composition-api/caveats
const name = toRef(props, 'name');
const value = toRef(props, 'value');

watch([value], () => {
  if (value.value) {
    setValue(value.value);
  } else {
    resetField({
      value: '',
      touched: false,
      errors: []
    })
  }
})

// we don't provide any rules here because we are using form-level validation
// https://vee-validate.logaretm.com/v4/guide/validation#form-level-validation
const {
  value: inputValue,
  errorMessage,
  handleBlur,
  handleChange,
  resetField,
  setState,
  setValue,
  meta,
} = useField(name, undefined, {
  initialValue: props.value,
});
const emit = defineEmits(['change'])
const changedValue = (ev) => {
    // if (props.type !== 'email' && props.type == 'text') {
    //   let val = ev ? ev[0].toUpperCase() + ev.slice(1) : "";
    //   setValue(val);
    // }
    emit('change', ev)
}

</script>

<template>
  <div
    class="TextInput"
    :class="{ 'has-error': !!errorMessage, success: meta.valid }"
  >
 
          <label class="d-block" v-if="label">{{ label }} <span class="text-danger">*</span></label>
          <BFormInput v-if="type=='text'"
            ref="input"
            maxlength="30"
            v-capitalize
            :autofocus="autofocus"
            :state="errorMessage ? false : null"
            :name="name"
            :id="name"
            :type="type"
            :value="value"
            :readonly="readonly"
            :placeholder="placeholder"
            :disabled="disabled"
            @input="handleChange"
            @blur="handleBlur"
            @change="changedValue"
          />
          <BFormInput v-if="type!='text'"
            ref="input"
            maxlength="30"
            :autofocus="autofocus"
            :state="errorMessage ? false : null"
            :name="name"
            :id="name"
            :type="type"
            :value="value"
            :readonly="readonly"
            :placeholder="placeholder"
            :disabled="disabled"
            @input="handleChange"
            @blur="handleBlur"
            @change="changedValue"
          />
           <small class="text-danger" v-if="errorMessage">{{ errorMessage }}</small>

  </div>
</template>

<style scoped>
/* .has-error .form-control {
  background-image: url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='red'%3E%3Ccircle cx='6' cy='6' r='4.5'/%3E%3Cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3E%3Ccircle cx='6' cy='8.2' r='.6' fill='%23a4c008' stroke='none'/%3E%3C/svg%3E");
  background-repeat: no-repeat;
  background-size: calc(.725em + .438rem) calc(.725em + .438rem)
}
.has-error .form-control:focus {
  background-image: url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='red'%3E%3Ccircle cx='6' cy='6' r='4.5'/%3E%3Cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3E%3Ccircle cx='6' cy='8.2' r='.6' fill='%23a4c008' stroke='none'/%3E%3C/svg%3E");
  background-repeat: no-repeat;
  background-size: calc(.725em + .438rem) calc(.725em + .438rem)
} */

</style>
